#include <bits/stdc++.h>

using namespace std;

int main()
{

    int n, k, x=0;
    cin>>n>>k;
    int a[k];

    for(int i=0; i<k; i++){
        x=0;
        cin>>a[i];
        for(int j=1; j<=sqrt(a[i]); j++)

            if(a[i]%j==0)
                if(a[i]/j==j)
                    x=x^j;
                else
                    x=x^j^(a[i]/j);
                cout<<x<<endl;
    }



    return 0;
}